/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
** last changes 21/11/01 CK                                           **
**                                                                    **
***********************************************************************/
void pass1(void)
{
 {
 bp1=strpos(input, "[");
 bp2=strpos(input, "]");
 
 if (bp2<=bp1) bp1=strpos(input,"=");
 if (bp1<0) bp1=strpos(input,";");

 if (bp1>0) sprintf(svar,"%s",strmid(input,0,bp1));
    else sprintf(svar,"%s",input);

 }
if (type == STATE || type == INT_PARAM || type == REAL_PARAM)
{
bp1=strpos(input,"{");
bp2=strpos(input,"}");
while (bp2 == -1)
  {
  fgets(helpstr,100,global_defs);
  strcat(input,helpstr);
  bp2=strpos(input,"}");
  }

fprintf(struct_def,"printf(\"Initializing: %s  from %s\\n\");\n",strclip(input),definition_file); 
sprintf(input,"%s",strmid(input,bp1+1,bp2-bp1-1));
strtrim(input);
expand(input);
}

switch (type)
 {
   case 0:break;

/* 0D Faelle */
  case _0D_STATE:
         fprintf(struct_def,"printf(\"Initializing: %s  from %s\\n\");\n",strclip(input),definition_file); 
         bp1=strpos(input,"=");
         bp2=strpos(input,";");
         if (bp1<0 || bp2<0)
         {
            printf("Error: Missing delimiter in definition %s from %s!\n",input,definition_file);
            exit(1);
         }
         sprintf(input,"%s",strmid(input,bp1+1,bp2-bp1-1));
         get_flt=my_sscan(input);
         fprintf(struct_def,"%s= %g ;\n",svar,get_flt);
         break;
  case _0D_GLOBAL:break;
    
/* 1D Faelle */

  case STATE:for (k=1;k<=boxes;k++)
         {
         bp1=strpos(input,",");
         if ( bp1 > 0 )
          {
          sprintf(helpstr,"%s",strmid(input,0,bp1));
          sprintf(input,"%s",strmid(input,bp1+1,strlen(input)-bp1-1));
          }
         else
          {
          sprintf(helpstr,"%s",input);
          }
         get_flt=my_sscan(helpstr);

         fprintf(struct_def,"%s[%d]= %g ;\n",svar,k,get_flt);

         }
         break;

  case GLOBAL:break;

  case INT_PARAM:fprintf(struct_def,"%s=ivector(1,%d);\n",svar,boxes);

         if (numchar(input,",") != boxes-1)
         {
            printf("Error: Wrong number of values for %s!\n",svar);
            exit(1);
         }

         for (k=1;k<=boxes;k++)
         {
         bp1=strpos(input,",");
         if ( bp1 > 0 )
          {
          sprintf(helpstr,"%s",strmid(input,0,bp1));
          sprintf(input,"%s",strmid(input,bp1+1,strlen(input)-bp1-1));
          }
         else
          {
          sprintf(helpstr,"%s",input);
          }
         sscanf(helpstr,"%d",&get_int);

         fprintf(struct_def,"%s[%d]= %d ;\n",svar,k,get_int);
         }
         break;

  case REAL_PARAM:fprintf(struct_def,"%s=vector(1,%d);\n",svar,boxes);

         if (numchar(input,",") != boxes-1)
         {
            printf("Error: Wrong number of values for %s!\n",svar);
            exit(1);
         }
         for (k=1;k<=boxes;k++)
         {
         bp1=strpos(input,",");
         if ( bp1 > 0 )
          {
          sprintf(helpstr,"%s",strmid(input,0,bp1));
          sprintf(input,"%s",strmid(input,bp1+1,strlen(input)-bp1-1));
          }
         else
          {
          sprintf(helpstr,"%s",input);
          }
         get_flt=my_sscan(helpstr);

         fprintf(struct_def,"%s[%d]= %g ;\n",svar,k,get_flt);
         }
         break;


   case REAL_CONST:break;
   case INT_CONST:break;
   case DERIVES:break;
   case FEATURES:break;

 /* 2D Faelle */
  case _2D_STATE:
/* 2D-States werden nur mit Null initialisiert */
/*  fprintf(struct_def,"for(__i=1;__i<=g_comp1;__i++)\n");
  fprintf(struct_def,"      for(__j=1;__j<=g_comp2;__j++)\n");
  fprintf(struct_def,"            %s[__i][__j]=0.0;\n",svar);*/
         bp1=strpos(input,"{");
         bp2=strpos(input,"}");
         sprintf(input,"%s",strmid(input,bp1+1,bp2-bp1-1));
         expand(input);
         if (numchar(input,",") != (boxes1*boxes2)-1)
         {
            printf("Error: Wrong number of values for %s!\n",svar);
            exit(1);
         }

         for (k=1;k<=boxes1;k++)
             for (l=1;l<=boxes2;l++)
            {
               bp1=strpos(input,",");
               if ( bp1 > 0 )
                {
                sprintf(helpstr,"%s",strmid(input,0,bp1));
                sprintf(input,"%s",strmid(input,bp1+1,strlen(input)-bp1-1));
                }
                else
                {
                sprintf(helpstr,"%s",input);
                }
                get_flt=my_sscan(helpstr);
                fprintf(struct_def,"%s[%d][%d]= %f ;\n",svar,k,l,get_flt);
                }
         
         break;

  case _2D_GLOBAL:break;

  case _2D_INT_PARAM:fprintf(struct_def,"%s=imatrix(1,%d,1,%d);\n",svar,boxes1,boxes2);

         bp1=strpos(input,"{");
         bp2=strpos(input,"}");
         sprintf(input,"%s",strmid(input,bp1+1,bp2-bp1-1));
         expand(input);
         if (numchar(input,",") != (boxes1*boxes2)-1)
         {
            printf("Error: Wrong number of values for %s!\n",svar);
            exit(1);
         }

         for (k=1;k<=boxes1;k++)
             for (l=1;l<=boxes2;l++)
            {
               bp1=strpos(input,",");
               if ( bp1 > 0 )
                {
                sprintf(helpstr,"%s",strmid(input,0,bp1));
                sprintf(input,"%s",strmid(input,bp1+1,strlen(input)-bp1-1));
                }
                else
                {
                sprintf(helpstr,"%s",input);
                }
                sscanf(helpstr,"%d",&get_int);
                fprintf(struct_def,"%s[%d][%d]= %d ;\n",svar,k,l,get_int);
                }
         break;

  case _2D_REAL_PARAM:fprintf(struct_def,"%s=matrix(1,%d,1,%d);\n",svar,boxes1,boxes2);

         bp1=strpos(input,"{");
         bp2=strpos(input,"}");
         sprintf(input,"%s",strmid(input,bp1+1,bp2-bp1-1));
         expand(input);
         if (numchar(input,",") != (boxes1*boxes2)-1)
         {
            printf("Error: Wrong number of values for %s!\n",svar);
            exit(1);
         }

         for (k=1;k<=boxes1;k++)
             for (l=1;l<=boxes2;l++)
            {
               bp1=strpos(input,",");
               if ( bp1 > 0 )
                {
                sprintf(helpstr,"%s",strmid(input,0,bp1));
                sprintf(input,"%s",strmid(input,bp1+1,strlen(input)-bp1-1));
                }
                else
                {
                sprintf(helpstr,"%s",input);
                }
                get_flt=my_sscan(helpstr);

         fprintf(struct_def,"%s[%d][%d]= %g ;\n",svar,k,l,get_flt);
         }
         break;


   case _2D_DERIVES:break;
   case _2D_FEATURES:break;

   default:break;
         }
} /* ende von pass1 */ 
