/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include "constructs.h"
#include "prepare.h"
#include "struct.h"

void read_0D_start_values(char *filename )
{
FILE *startfile;
char *input_buf,*line_buf,*list,*change_buf,*message;
char *dummy __attribute__ ((unused));
int bp1,bp2,i,k,cp,found=0;
name test_name,left_part;

line_buf=(char *) malloc(_BUFSIZE_*sizeof(char));
message=(char *) malloc(_BUFSIZE_*sizeof(char));
change_buf=(char *) malloc(_BUFSIZE_*sizeof(char));
input_buf=(char *) malloc(_BUFSIZE_*sizeof(char));
list=(char *) malloc(_BUFSIZE_*sizeof(char));

startfile=fopen(filename,"rb");

/* erstmal aus den Skalaren in die globalen Strukturen schreiben */
make_global_0D_states();

/* Suche nach "%change" */
while ( (k=fgetc(startfile)) != EOF )
  {
  ungetc(k,startfile);
  input_buf=fgets(input_buf,100,startfile);
  if (strpos(input_buf,_keyword_) == 0)
     if (strpos(input_buf,change_id)>=0) 
      {
      found=1;
      break;
      }
  }
/* "%change" gefunden, eine Zeile einlesen */

if (found==0) goto stop_label;

/* Erstmal die globale Struktur mit den Initialwerten füllen */
make_global_0D_states();

printf("Reading 0D start values.....\n");

while ( (k=fgetc(startfile)) != EOF )
 {
 ungetc(k,startfile);
 input_buf=fgets(input_buf,100,startfile);

 while(strlen(input_buf)<3) 
  {
  k=fgetc(startfile);
  if (k == EOF ) goto stop_label;
  ungetc(k,startfile);
  input_buf=fgets(input_buf,100,startfile);
  }
 sprintf(line_buf,"%s",input_buf);

/* Zeile komplettieren */
  bp1=strpos(line_buf,"=");
  bp2=strpos(line_buf,";");
  if (bp1>0)
   {
   while (bp2<0)
    {
    dummy=fgets(input_buf,100,startfile);
    line_buf=strcat(line_buf,input_buf);
    bp2=strpos(line_buf,";");
    }
   }
 strtrim(line_buf);
 sprintf(message,"%s",line_buf);

/* Eingelesene Zeile in einzelne Kommandos zerlegen */

 while(strlen(line_buf)>0)
  {
  cp=strpos(line_buf,";");

  sprintf(change_buf,"%s",strmid(line_buf,0,cp+1));
  sprintf(line_buf,"%s",strmid(line_buf,cp+1,(int) strlen(line_buf)-cp-1));

/* Fuehrende white-space abschneiden */
  while(strpos(change_buf," ")==0) sprintf(change_buf,"%s",strmid(change_buf,1,(int) strlen(change_buf)-1));
     if (strlen(change_buf)==0) break;
     if (strpos(change_buf,"=") < 0) break;
/* Nach passender Variablen suchen */
     for (i=1; i<=num_0D_states; i++)
       {
       sprintf(test_name,"%s",_0D_state_names[i]);
       cp = strpos(change_buf,"=");
   
       sprintf(left_part,"%s",strmid(change_buf,0,cp));
       if (strpos(left_part,test_name) == 0 && strlen(test_name)==strlen(left_part))
        {
        bp1=strpos(change_buf,";");
        if (bp1<0 ) 
        {
           printf("Error in line containing: %s\n",change_buf);
           std_error("Brackets missing or no indices (rs0D_1)");
        }
        sprintf(list,"%s",strmid(change_buf,cp+1,bp2-cp-1));
        printf("%s\n",change_buf);
        fflush(stdout);
           if (strlen(list) == 0) 
           {
              printf("Error in line containing: %s\n",message);
              std_error("No value given? (rs0D_2)");
           }
           KKK[i]=my_sscan(list);
           }
          }
         break; /* wenn gefunden, Variablenliste beenden */

  } /* Ende von while strlen(line_buf)>0 */
 } /* Ende von while != EOF */

stop_label:
/* jetzt aus den globalen Strukturen in die Skalaren schreiben */
make_local_0D_states();
fclose(startfile);
free(line_buf);
free(input_buf);
free(change_buf);
free(list);
free(message);
}


   
