/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
/*
last change:

*/
#include "stdinc.h"
#include "types.h"
#include "constructs.h"
#define _BUFSIZE_ 65536

int cpp2c(string input_file,string output_file)
{
  long int cp;
  FILE *in_file,*out_file;
  char* input;
 
  input= (char *) malloc( _BUFSIZE_*sizeof(char));

  in_file = fopen(input_file,"r");

  if (in_file == NULL)
  {
     std_error("cpp2c: Error when opening file for reading");
  }
  
  out_file=fopen(output_file,"wb");

  while ( fgets(input,_BUFSIZE_,in_file) != 0) 
  {  
/*      strtrim(input);*/
      cp=strpos(input,"//");
      if (cp < 0)
      {
	fprintf(out_file,"%s\n",input);
      }	

      if (cp >= 0)
      {
	fprintf(out_file,"%s\n",strmid(input,0,cp));
      }	
  }
  fclose(in_file);
  fclose(out_file);
  free(input);
  return(0);
}
