/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include "stdinc.h"
#include "constructs.h"
#include "prepare.h"


void get_str(char *filename,char *search,char *par_name, char *value)
{
   FILE *para_file;
   char *helpstr, *input;
   int comment;
   int found=-1;
   input=(char *) malloc(_BUFSIZE_*sizeof(char));
   helpstr=(char *) malloc(_BUFSIZE_*sizeof(char));

   para_file=fopen(filename,"rb");

/* search-Block suchen */
   while (found < 0)
      {
      if (fscanf(para_file,"%s",helpstr) == EOF) goto stop_label;
      found=strpos(helpstr,search);
      }

/* Nach Variablen suchen, deren Inhalt geaendert werden soll */

   while (fscanf(para_file,"%s",helpstr) != EOF)
     {
     comment=strpos(helpstr,rem1);
     while (comment >= 0)
       {
       if (strpos(helpstr,rem2) >= 0) comment=-1;
       if (fscanf(para_file,"%s",helpstr) == EOF) goto stop_label;
       } /* ende von comment>=0 */

       sprintf(input,"%s",helpstr);
       if (strpos(input,par_name) >= 0)
          {
           comment=fscanf(para_file,"%s",value);
#if defined (__verbose__)
           printf("%s %s \n",par_name,value);
           fflush(stdout);
#endif
          }

      }
    stop_label:
    free(input);
    free(helpstr);
    fclose(para_file);
}


