# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc batchcompile {what modelhome debug} {
global cemoshome cemhome pwd DOS netCDFHOME GUI

if ![file isdirectory $modelhome] {puts "No valid directory given";exit}


# Liste der General compile flags
# werden in gflagarr zusammengefasst. Indexe sind die Elemente von  general_flaglist

global general_flaglist
set general_flaglist "g m32 static ansi pedantic D__verbose__ D__accept_nega_with_zero_rate__ Wredundant-decls Wstrict-prototypes"
lappend general_flaglist Wextra Wshadow Wfloat-equal Wunreachable-code 
lappend general_flaglist   fsignaling-nans     
if {$DOS==0} { 
    lappend general_flaglist pg Wunused-result Wno-unused-result Wunused-but-set-variable Wno-unused-but-set-variable efence gsl
}
#Initialisierung der arrays
global gflagarr
foreach item $general_flaglist {set gflagarr($item) 0}

# Liste der Modell compile flags
# werden in cflagarr zusammengefasst. Indexe sind die Elemente von  compile_flaglist
global compile_flaglist
set compile_flaglist "O O2 O3 O4 Wall"

#Initialisierung der arrays
global cflagarr gflagarr
foreach item $compile_flaglist {set cflagarr($item) 0}


# Compiler-Optionen zusammenbauen

if {$debug==""} {

#                        set cflagarr(O2)  1
#                        set cflagarr(Wall)  1
make_default_list
}

if {$debug=="debug"} {

#                        set gflagarr(g) 1
#                         set gflagarr(pedantic)  1
#                         set gflagarr(D__verbose__)  1
#                         set gflagarr(Wredundant-decls)  1
#                         set cflagarr(Wall)  1

 make_debug_list

}

set gflags [make_generalflags]
set cflags [make_compileflags]
set lflags [make_linkflags]

# Compile starten
if {$what =="compile"} {compile $modelhome $gflags $cflags $lflags}
if {$what =="cup"} {cup $modelhome $gflags $cflags $lflags}

}







