# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc cev_gui_distmenu { } {
global c2 pady difftype lfont mp anzp allbuts alltext

labelframe .topp.distance -bg $c2 -text "Distances & Optimization Control"
grid .topp.distance -row 8 -column 0 -sticky news

frame .topp.distance.distp -bg $c2
pack .topp.distance.distp -side left

label .topp.distance.distp.text -text "  Distance:" -font $lfont
pack  .topp.distance.distp.text -side left 
lappend alltext .topp.distance.distp.text

menubutton .topp.distance.distp.diff -text "Select" -menu .topp.distance.distp.diff.menu -font $lfont
pack .topp.distance.distp.diff -side left
lappend allbuts .topp.distance.distp.diff
lappend alltext .topp.distance.distp.diff

set mp [menu .topp.distance.distp.diff.menu -tearoff 0]
set distlabel(0) "Pointwise 1: w*(g(t)-f(t))^2" 
set distlabel(1) "Pointwise 2: |f(t)-g(t)|/|f(t)+g(t)|" 
set distlabel(2) "Pointwise 3: |f(t)-g(t)|/min\[|f(t)|,|g(t)|\]" 
set distlabel(3) "Pointwise 4: |f(t)-g(t)|/(|f(t)|+|g(t)|-|f(t)-g(t)|)" 
set distlabel(4) "Pointwise 5: |ln(|f(t)/g(t)|)|"
set distlabel(5) "Pointwise 6: max\[|g(t)/f(t)|,|f(t)/g(t)|\]-1"
                  
set anzp 6
for {set i 0} {$i < $anzp} {incr i} {
    $mp add radio -label $distlabel($i) -variable difftype -value [expr $i+1] \
     -command " .topp.distance.distp.diff config -text {$distlabel($i)};cev_reset;ppp" -font $lfont
}
# L2-Distanzen
$mp add separator

set distlabel(10) "Spectral 11: ||f-g||/||f+g||" 
set distlabel(11) "Spectral 12: ||f-g||/min(||f||,||g||)" 
set distlabel(12) "Spectral 13: ||f-g||/(||g||+||f||-||f-g||)" 
set distlabel(13) "Spectral 14: 1-<f,g>/(||f||||g||)" 
set distlabel(14) "Spectral 15: (||f||||g||-<f,g>)/(||f||||g||+<f,g>)" 
set distlabel(15) "Spectral 16: arccos(<f,g>)/(||f||||g||))" 
set distlabel(16) "Spectral 17: |ln(||f||/||g||)|" 
set distlabel(17) "Spectral 18: max(||f||/||g||,||g||/||f||)-1" 
set distlabel(18) "Spectral 19: No. 6 + No. 7"    
          
for {set i 10} {$i < 19} {incr i} { 
    $mp add radio -label $distlabel($i) -variable difftype -value [expr $i+1] \
     -command ".topp.distance.distp.diff config -text {$distlabel($i)};cev_reset;ppp" -font $lfont
}

# Menuentries sind von 0 durchnummeriert
#	  if {$difftype<11} {set index [expr $difftype -1]} else {set index [expr $difftype+$anzp-10]}
#
#global oldtype
#puts "cev_gui_distmenu: $difftype $oldtype $index"

#puts "menu1 $difftype"
#puts $index
#$mp invoke $index
#puts "menu2 $difftype"
update
update idletasks

}

proc ppp {} {
global difftype
put "Distance: $difftype"
}
