# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
#--------------------
# Select Reference  Resultfile
#--------------------
proc cev_gui_select_cin {} {
global lfont cin_file pwd browsedir

.topp.filo.info.info2.cins  config -state disabled

toplevel .cin
wm title .cin {Select CIN File}
wm geometry .cin "+270+370"
wm protocol .cin  WM_DELETE_WINDOW {cancelcin}
wm attributes .cin -topmost yes

frame .cin.up
pack .cin.up
   
set browsedir $pwd

entry .cin.up.text -width 50 -textvariable cin_file -font $lfont
pack .cin.up.text -side left

button .cin.up.choose -font $lfont -text {Browse}\
       -command {set cin_file [fileselect "CIN file" "cin" $browsedir open];if [winfo exist .cin] { raise .cin}}
pack .cin.up.choose -side left

frame .cin.but
pack .cin.but

button .cin.but.cancel -font $lfont -text {cancel} -command {cancelcin}
pack .cin.but.cancel -side left

button .cin.but.close -font $lfont -text {ok} -command {OKcin}
pack .cin.but.close -side left
}

proc OKcin {} {
global cin_file
put "Selected $cin_file as CIN-File for settings"
.topp.filo.info.info2.cins config -state normal
.topp.filo.info.info2.cin config -text "$cin_file"
destroy .cin
}

proc cancelcin {} {
global cin_file
.topp.filo.info.info2.cins  config -state normal
.topp.filo.info.info2.cin config -text "$cin_file"
destroy .cin
}

