/* CEMOS/CEMTK 4.0 Copyright (C) 2007, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

static char output[_BUFSIZE_];

long int strpos(char* string,char* search)
 {
 char *pos;
 pos=strstr(string,search);
 if (pos != NULL)
    pos=(char*) (pos-string);
 else
    pos=(char*) -1;

 return (long int) pos;
 }


char *strmid(char* string,long int start, long int len)
 {
 char *s_pos;
 if (start != -1)
    {
    s_pos=(char*) (string+start);
    strncpy(output,s_pos,len);
    output[len]=(char) 0;
    }
  return output;
  }

void strtrim(char* instring)
 {
 long int i,j=0;
 for (i=0;i<(int)strlen(instring);i++) if (!isspace(instring[i])) output[j++]=instring[i];
 output[j]=(char) 0;
 sprintf(instring,"%s",output);
 }


char *strtolower(char* string)
 {
 long int i;
 for (i=0; string[i]!='\0';i++)
    {
    string[i]= tolower(string[i]);
    }

 return string;
 }

float my_sscan(char* input)
{
float value;
sscanf(input,"%e",&value);
return(value);
}

int numchar(char* string,char* search)
{
unsigned int i;
int cnt=0;

  for (i=0;i<strlen(string);i++)
  {
     if ( strpos(strmid(string,i,1),search) >= 0) cnt++;
  }
return(cnt);
}

real rmin( real a, real b)
{ 
return ((a<b) ? a : b); 
}

real rmax( real a, real b)
{ 
return ((a>b) ? a : b); 
}

real rabs( real a )
{ 
return ((a>=0.0) ? a : -a); 
}


