# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc startcin {} {
global batname pwd
global cindirrem
set cin_error 0

if ![info exist cindirrem] {set cindirrem $pwd}

set cinname ""
set cinname [fileselect "Select CIN File" cin $cindirrem open]

if {$cinname!=""} {
   set cin_id [open $cinname r]
   set linecounter 0
   while {[eof $cin_id]==0} {
       gets $cin_id cin_line
       incr linecounter
       if {[string match \#include* $cin_line] && [string match *.def* $cin_line]} {
           put "Error: in file:$cinname"
           put "at line $linecounter: $cin_line" 
           put "Error: Including a definition file is not allowed from .cin files!"
           set cin_error 1
       }
    }
    close $cin_id
    if {$cin_error == 0 } {
        set cindirrem [file dir $cinname]
        #set cinname [file tail $cinname]
        set batname "$pwd/cin.bat"

        set batout [open $batname w]
        puts $batout "\#include \"$cinname\""
        close $batout
        startbatch 0 1
    } else {
        put "Execution of cin-file stopped!"
    }
}
}
