/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{
void *readheader(FILE*,header*,int);
FILE *unit;
header oh;
char *resultname;
void *all;
string helpstr;

int i,namelength;

resultname=argv[1];


unit=fopen(resultname,"rb");
if (unit != NULL)  {

   if (strpos(resultname,".outb") > 0) {
       namelength = sizeof(name12);
    } else {
       namelength = sizeof(long_name80);
    }
    all = readheader(unit,&oh,namelength);
    printf("%d ",oh.nvars);
    printf("%f ",oh.startim);
    printf("%f ",oh.endtim);
    printf("%f ",oh.maxdelt);
    printf("%f ",oh.outdelt);
    printf("%f ",oh.year);
    printf("%f ",oh.cycle);
    printf("%s \n",oh.sdir);
    for (i=0;i<oh.nvars;i++) {
       sprintf(helpstr,"%s",strmid(all,i*namelength,namelength));
       printf("%s\n",helpstr);
    }
    fclose(unit);
    return(0);
} else {
   printf ("Error in readall: No file %s\n",resultname);
   return(1);

}
}
