# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc harm_control {} {
global filename dataname filelist
global numharm maxharm minharm harmend startharm harm
global buttonFont
global ovc
set harm 0
set minharm infinity
set maxharm 0

set pk 0
foreach a $filelist {
 if [info exist numharm($a)] {
    set minharm [min $minharm $numharm($a)]
    set maxharm [max $maxharm $numharm($a)]
    set pk 1
 }
}
set harmend $minharm

if {$pk==1} {

  frame $ovc.left.pk
  pack $ovc.left.pk -fill x

  frame $ovc.left.pk.but
  pack $ovc.left.pk.but -fill x

  checkbutton $ovc.left.pk.but.fourier  -font $buttonFont -text {Spectrum} \
       -variable spectrum -anchor w \
       -command {
		 if {$spectrum==1} {
    		destroy .valu
            set multiset 0
		    set eraseallsets 0
		    bind_multiset 0
            set valu 0
		    set barchart 1
		    set harm 10
		    set harmend [min $maxharm 200]
		    set startharm 0
		    $ovc.right.misc.bar config -state disabled
            $ovc.left.pk.harm config -to $harmend
            $ovc.left.pk.harm2 config -state normal
            $ovc.left.pk.harm2 config -fg black
            $ovc.left.pk.but.power config -state normal
    	    disableslider
		 } else {
		    set barchart 0
            set harm 0
		    set harmend $minharm
            set startharm 0
            set power_spec 0
            $ovc.right.misc.bar config -state normal
		    $ovc.left.pk.but.power config -state disabled
            $ovc.left.pk.harm config -to $harmend
            $ovc.left.pk.harm2 config -state disabled
            $ovc.left.pk.harm2 config -fg #d0d0d0
			enableslider
		 }
		 makecommand -1 -1
		}
  pack $ovc.left.pk.but.fourier -side left -fill x

  checkbutton $ovc.left.pk.but.power  -font $buttonFont -text {Power Spectrum} \
    -variable power_spec -anchor w -command {makecommand -1 -1}
  pack $ovc.left.pk.but.power -anchor e
  $ovc.left.pk.but.power config -state disabled

  set startharm 0
  scale $ovc.left.pk.harm2  -font $buttonFont -from 0 -to $harmend -variable startharm \
        -orient horizontal -label "First harmonic" -resolution 1
  pack $ovc.left.pk.harm2 -fill x
  bind $ovc.left.pk.harm2 <ButtonRelease-1> "corrStartHarm"
  $ovc.left.pk.harm2 config -state disabled
  $ovc.left.pk.harm2 config -fg #d0d0d0


  scale $ovc.left.pk.harm  -font $buttonFont -from 0 -to $harmend -variable harm \
      -orient horizontal -label "Num. of harmonics" -resolution 1
  pack $ovc.left.pk.harm -fill x
  bind $ovc.left.pk.harm <ButtonRelease-1> "corrHarmwin"
}
}
