# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc prep_com {j} {
# j = graph
global ymin ymax
global command
global sameaxis valu
global filename
global singleresult
global lbar
global filelist
global minnumber maxnumber

foreach selectvar $command($j) {

  set yminrem($j)  $maxnumber
  set ymaxrem($j)  $minnumber
  set lbar 0

  foreach k $filelist {

    if [info exists filename($k)] {
       extract_result $k
       eval_slid $j $k
       calc_ext $j
       set singleresult($k,$selectvar) $singleresult($selectvar)
       set yminrem($j) [min $yminrem($j) $ymin($j)]
       set ymaxrem($j) [max $ymaxrem($j) $ymax($j)]
       incr lbar
    }
  }
}

set ymin($j) $yminrem($j) 
set ymax($j) $ymaxrem($j)
if {$valu == 1} {prep_valu $j}

}


