# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc prep_valu {j} {
# j = graph
global starttime endtime outdelt year cycle timewin
global actstart
global ymin ymax
global valtime valdata
global valinb valint valper valstd
global valu valushow
global vtim vdat
global vint vinb vper vstd
global lbar
global timflag meanflag
global filelist datalist
global allyear

foreach a $datalist {
if {$valushow($a)==1} {
    set actend [expr $actstart(1)+$timewin]

    if {$timflag($a)==0} {
       if {$allyear==1} {set num [expr $actend/$cycle(1)]} else {set num 1}
    } else {
       set num 1
    }

    if [info exists vtim($a,$j)] {unset vtim($a,$j)}
    if [info exists vdat($a,$j)] {unset vdat($a,$j)}
    if [info exists vint($a,$j)] {unset vint($a,$j)}
    if [info exists vinb($a,$j)] {unset vinb($a,$j)}
    if [info exists vper($a,$j)] {unset vper($a,$j)}
    if [info exists vstd($a,$j)] {unset vstd($a,$j)}

    if [info exists valdata($a,$j)] {
     incr lbar

     if [info exists avtim] {unset avtim}
     set avdat ""
     set avint ""
     set avinb ""
     set avper ""
     set avstd ""
     

     for {set n 0} {$n<$num} {incr n} {
          foreach item $valtime($a,$j) {
             lappend avtim [expr $item + $n*$cycle(1)]
          }
          set avdat [concat $avdat $valdata($a,$j)]
          if [info exists valint($a,$j)] {set avint [concat $avint $valint($a,$j)]}
          if [info exists valinb($a,$j)] {set avinb [concat $avinb $valinb($a,$j)]}
          if [info exists valper($a,$j)] {set avper [concat $avper $valper($a,$j)]}
          if [info exists valstd($a,$j)] {set avstd [concat $avstd $valstd($a,$j)]}
     }

     set vfirst($a) 0
     set vlast($a) 0
     
     set vtim($a,$j) ""
     set vdat($a,$j) ""
     set vint($a,$j) ""
     set vinb($a,$j) ""
     set vper($a,$j) ""
     set vstd($a,$j) ""

     set i 0
    
     foreach number $avtim {
        #if {$number < $actstart(1)} {incr vfirst($a)}
        #if {$number > $actend} {incr vlast($a)}

        if {$number >= $actstart(1) && $number<=$actend} {
          lappend vtim($a,$j) [lindex $avtim $i]
          lappend vdat($a,$j) [lindex $avdat $i]
	  

          if [info exists valint($a,$j)] {lappend vint($a,$j) [lindex $avint $i]}
          if [info exists valinb($a,$j)] {lappend vinb($a,$j) [lindex $avinb $i]}
          if [info exists valper($a,$j)] {lappend vper($a,$j) [lindex $avper $i]}
          if [info exists valstd($a,$j)] {lappend vstd($a,$j) [lindex $avstd $i]}


        }
     incr i
     }



#     scan [expr [llength $avdat]-$vlast($a)-1] %d vlast($a)
#     set vtim($a,$j) [lrange $avtim $vfirst($a) $vlast($a)]
#     set vdat($a,$j) [lrange $avdat $vfirst($a) $vlast($a)]
     
     if {$meanflag ==1} { 
        set vdat($a,$j) [lmean $vdat($a,$j)]
     } else {

        if [info exists valint($a,$j)] {
            set ymax($j) [max $ymax($j) [lmax $vint($a,$j)]]
        }

        if [info exists valinb($a,$j)] {
            set ymin($j)  [min $ymin($j) [lmin $vinb($a,$j)]]
        }
      }
  
       set ymax($j) [max $ymax($j) [lmax $vdat($a,$j)]]
       set ymin($j) [min $ymin($j) [lmin $vdat($a,$j)]]
    }
 }
}
}


