# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc eval_cont_slid {j} {
global starttime outdelt
global filmdata profdata command
global startbox boxwindow
global actstart timewin first last
global layer layersum evallayer tiefe
global not_stored
global selectvar

scan [expr ($actstart(1)-$starttime(1))/$outdelt(1)] %d first
scan [expr $first +$timewin/$outdelt(1)] %d last

set lastbox [expr $startbox + $boxwindow]

foreach selectvar $command($j) {

  for {set i $startbox} {$i <= $lastbox} {incr i} {
       
       regsub -all {[(][0-9]+[)]} $selectvar "($i)" selectvar_i

      if {$not_stored($selectvar_i)==0} {
         set filmdata($i) $profdata($selectvar,$i,1)
      } else {
         set filmdata($i) ""
      }

  }
}

set layersum 0
for {set j $first} {$j <= $last} {incr j} {

  set layersumj 0

  for {set i $startbox} {$i <= $lastbox} {incr i} {

     set layer($i,$j) [lindex $profdata(layer,$i,1) $j]
     
     

     if { ![info exist layer($i,$j)] || $layer($i,$j) =="not_stored" || $layer($i,$j) =="" || $layer($i,$j) ==-999} {set layer($i,$j) 1 }

     set layersumj [expr $layersumj+$layer($i,$j)]

  }
  set layersum [max $layersum $layersumj]
}




set tiefe($startbox) 0
for {set i $startbox} {$i <= $lastbox} {incr i} {
   set tiefe([expr $i+1]) [expr $tiefe($i)+$layer($i,$first)]
   
   if {$evallayer==0} {
       for {set j $first} {$j <= $last} {incr j} {set layer($i,$j) 1}
   }

}

if {$evallayer==0} {set layersum [expr $lastbox-$startbox+1]}

}

