# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc createcontrol {} {
global onewindow ovc can toolflag mf bs

setvars

# Control Panel
#Control Panel
if [info exists ovc] { if [winfo exists $ovc] {destroy $ovc}}
update idletasks

if {$onewindow==0} {
	set ovc .ovc
	toplevel $ovc
	wm title $ovc {Control Panel}
	wm geometry $ovc "+[expr $can+80]+350"
	wm group $ovc .
	wm transient $ovc .
	wm protocol $ovc WM_DELETE_WINDOW exit
	set max_frameheight [expr 3*[winfo screenheight .]/2] 
	set max_framewidth [expr [winfo screenwidth .]/4] 

} else { 
	set ovc $mf.right.combo.control
	labelframe $ovc -padx 5 -pady 10 -borderwidth 1 -relief groove -text "Control"

#	scrolledframe $ovc -padx 5 -pady 10 -borderwidth 1 -relief groove -xscroll [list $ovc.hsb set] -yscroll [list $ovc.vsb set]
#	scrollbar $ovc.vsb -command [list $ovc yview]
#	scrollbar $ovc.hsb -command [list $ovc xview] -orient horizontal
	grid $ovc -row 1 -column 0 -sticky nw 
#	grid $ovc.scrolled -row 0 -column 0 -sticky nw
#	grid $ovc.vsb -row 0 -column 1 -sticky ns
#	grid $ovc.hsb -row 1 -column 0 -sticky ew
	set max_frameheight [expr $can + [winfo height $bs] - [winfo height .mf.right.msg]]
	set max_frameheight [expr $can + [winfo height $bs]]
	set max_framewidth [expr [winfo width $mf.right] -200]

}

frame $ovc.left
grid  $ovc.left  -column 0 -row 0 -sticky news

switch $toolflag {
    overview {OvControl}
    compare {CompControl}
    contour {ContControl}
    phase {PhaseControl}
    profile {profControl}
    profcom {profcomControl}
    text {TextControl}
    film {FilmControl}
}
set req_frameheight [winfo reqheight $ovc.left]
set req_framewidth [winfo reqwidth $ovc.left]
set frameheight [min $req_frameheight $max_frameheight]
set framewidth [min $req_framewidth $max_framewidth]
#puts "max_frameheight:$max_frameheight req_frameheight:$req_frameheight frameheight:$frameheight"
#puts "max_framewidth:$max_framewidth req_framewidth:$req_framewidth framewidth:$framewidth"
if {$req_frameheight<$max_frameheight} {
	if [winfo exist $ovc.vsb] {grid forget $ovc.vsb}
}
if {$req_framewidth<$max_framewidth} {
	if [winfo exist $ovc.vsb] {grid forget $ovc.hsb}
}
#$ovc.scrolled config -height [expr $frameheight - 2] -bg red
#$ovc config -bg blue
#$ovc.left config -bg green
#$ovc.right config -height 800 -bg yellow
update
update idletasks
}
