# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc createboxes { {color -1} } {
global canvas actbox map  obj mapname
if {$color==-1} {set color [option get . background {}]}
erase $canvas all

for {set i 1} {$i <= $actbox} {incr i} {
  set help $map($i)

  set item [eval $canvas create $obj $help \
                 {-width 1 -fill $color -outline black}]
  
  $canvas addtag drawbox($i) withtag $item
}

drawnum
}


proc drawoutline {} {
global actbox
global canvas

for {set i 1} {$i <= $actbox} {incr i} {
   $canvas itemconfig drawbox($i) -outline black
}
}


proc drawnum {} {
global actbox layer numpos boldFontN
global upper lower
global canvas toolflag
global mapname

if {$mapname != "mapripple"} {

erase $canvas allnum
for {set i 1} {$i <= $actbox} {incr i} {
  if {$layer == "upper"} {
     set nummer [lindex $upper [expr $i-1]]
  } else {
     set nummer [lindex $lower [expr $i-1]]
  }

  set item [eval $canvas create text $numpos($i) {-text $nummer -anchor c -font $boldFontN}]
#   set item [$canvas create text $numpos($i) -text $nummer -anchor c -font $boldFontN]
  $canvas addtag num($i) withtag $item
  $canvas addtag allnum withtag $item
  if {$toolflag=="film"} { $canvas bind num($i) <1> "boxview $nummer"}

}
$canvas bind allnum <Shift-Button-3> "$canvas delete allnum"

}

}

