# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc makefilmcolor {} {
global filmcolor colmax colmin coltab
global moviehome

if [info exists filmcolor] {unset filmcolor}

switch $coltab {
             black&white {
                set colmax 200
                set colmin 60
                set id [open $moviehome/film/colors/blackwhite.dat r]
               }
             blue&white { 
                set colmax 230
                set colmin 80
                set id [open $moviehome/film/colors/bluewhite.dat r]
               }
             green&white { 
                set colmax 230
                set colmin 80
                set id [open $moviehome/film/colors/greenwhite.dat r]
               }
             "red temperature" { 
                set colmax 230
                set colmin  80
                set id [open $moviehome/film/colors/redtemp.dat r]
               }
             prism {
                set colmax 192
                set colmin 86
                set id [open $moviehome/film/colors/prism.dat r]
               }
             phase {
#                 set colmax 12
#                 set colmin 0
#                 set id [open $moviehome/film/colors/phase.dat r]
#                 set colmax 243
#                 set colmin 0
#                 set id [open $moviehome/film/colors/prism.dat r]
                set colmax 200
                set colmin 0
                set id [open $moviehome/film/colors/phase.dat r]
               }


             }

set i 0
while {[gets $id line] >=0} {
  set r [format "%x" [lindex $line 0]]
  if {[string length $r] <2} {set r 0$r}

  set g [format "%x" [lindex $line 1]]
  if {[string length $g] <2} {set g 0$g}

  set b [format "%x" [lindex $line 2]]
  if {[string length $b] <2} {set b 0$b}

  set filmcolor($i) #$r$g$b
  incr i
}
close $id
}

