# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc boxslider {} {
global toolflag box comboxlist can
global buttonFont
global onewindow bs boxwin
# Box Slider
#-------------
if {($toolflag == "overview" || $toolflag == "compare" || $toolflag == "phase")} {
   
    if {$onewindow==0} {
	    if [winfo exist $bs] {destroy $bs}
	    if [winfo exist .ts] {destroy .ts}
	    set bs .ts
	    toplevel $bs
	    wm title $bs {Box Slider}
	    wm geometry $bs "+50+[expr $can +150]"
	    wm group $bs .
	    wm transient $bs .
	    wm protocol $bs WM_DELETE_WINDOW exit
    } 
  set ts $bs
  set kids [winfo children $ts]
  foreach kid $kids {destroy $kid}

  set first [lindex $comboxlist 0]
  set last  [expr [llength $comboxlist] +$first-1]
  scale $ts.speed  -font $buttonFont -length $can \
      -from $first -to $last\
      -variable box \
      -command "mchelp"\
      -orient horizontal \
      -tickinterval 5 \
      -showvalue true \
      -resolution 1 \
      -bigincrement 10
  grid $ts.speed -row 0 -column 0 -sticky news
  set boxwin $ts.speed
}
}


proc mchelp {box} {
makecommand -1 $box
}


 
