# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc corrStart {i} {
global endtime outd
global actstart actstartt timewin timewint
global connect
global filelist
global toolflag
global ovc

if [info exists connect] {
   if {$connect == 1} {
      foreach j $filelist {
         set actstart(1) [min $actstart(1) [expr $endtime($j) - $outd]]
      }
      foreach j $filelist {
        set actstart($j) $actstart(1)
      }
   }
}
#set actstart($i) [expr floor($actstart($i)/$outd)*$outd]
set actstart($i) [min $actstart($i) [expr $endtime($i) - $outd]]
set actstartt($i) $actstart($i)
set timewin [min $timewin [expr $endtime($i) -$actstart($i)]]
set timewint $timewin
disablestart
if {$toolflag != "film"} {interpret}
}

proc corrStartt {i} {
global actstart actstartt
set actstart($i) $actstartt($i)
corrStart $i
}

proc corrOutwin {} {
global outwin
global outd 
set outwin [max $outwin $outd]
interpret
}

proc corrTimewint {} {
global timewin timewint
set timewin $timewint
corrTimewin
}

proc corrTimewin {} {
global actstart actstartt starttime endtime timewin timewint
global outd
global filelist
global toolflag

set tempwin [expr $endtime(1) -$actstart(1)]
foreach i $filelist {
  set tempwin [min $tempwin [expr $endtime($i) -$actstart($i)]]
}
if {$timewin > $tempwin} {
  set tempwin [expr $endtime(1) -$starttime(1)]
  foreach i $filelist {
    set actstart($i) $starttime($i)
    set actstartt($i) $actstart($i)
    set tempwin [min $tempwin [expr $endtime($i) -$actstart($i)]]

  }
  set timewin $tempwin
}
set timewin [expr ceil($timewin/$outd)*$outd]
set timewin [max $timewin $outd]
set timewint $timewin
disablestart
if {$toolflag != "film"} {interpret}
}




proc sameAx {w} {
global sameaxis

if {$sameaxis ==1} {
   set sameaxis 0
   $w configure -text {same y-axis}
} else {
   set sameaxis 1
   $w configure -text {autoscale}
}
interpret
}

proc fixVar {f} {
global varwin aoag
global ovc bc

if {$f == 1} {
   foreach l $varwin { $l config -state disabled }
   $ovc.right.fix.aoag config -state normal
   $bc.nicevar configure -state disabled
} else {
	puts "f!=1"
   foreach l $varwin { $l config -state normal }
   $ovc.right.fix.fixbox config -state normal
   $bc.nicevar configure -state normal
   if {$aoag == 1} {$ovc.right.fix.aoag invoke}
   $ovc.right.fix.aoag config -state disabled
}
}

proc fixBox {f} {
global boxwin aoag
global ovc bc

if {$f == 1} {
   foreach l $boxwin { $l config -state disabled -fg grey}
   $ovc.right.fix.aoag config -state normal
   $bc.boxslid config -state disabled
} else {
   foreach l $boxwin { $l config -state normal -fg black}
   $ovc.right.fix.fixvar config -state normal
   $bc.boxslid config -state normal
   if {$aoag == 1} {$ovc.right.fix.aoag invoke}
   $ovc.right.fix.aoag config -state disabled
}
}

proc connectslid {} {
global connect maxfiles
global ovc slid

if {$connect==1} {
	for {set i 2} {$i<=$maxfiles} {incr i} {
		if [winfo exists $slid.scr.scrolled.start$i] {
			$slid.scr.scrolled.start$i configure -state disabled -fg grey
			$slid.scr.scrolled.tstart$i configure -state disabled
		}
	}
} else {
	for {set i 2} {$i<=5} {incr i} {
		if [winfo exists $slid.scr.scrolled.start$i] {
			$slid.scr.scrolled.start$i configure -state normal -fg black
			$slid.scr.scrolled.tstart$i configure -state normal
		}
	}
}


}


