# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc extract_result {a} {
global moviehome pwd
global command gc mm
global result spectrum distance
global runmean stepmean stepsum autocorr

# spectrum only valid in compare
if [info exist spectrum] {set spec $spectrum} else {set spec 0}
if [info exist distance] {if {$distance==1} {set spec 1}}

if ![info exist runmean] {set runmean 0}

# Loop over all graphs :
#########################

for {set i 0} {$i<= $gc} {incr i} {
  foreach item $command($i) {
     set result($item) [extract_one_set $a $item]
     if {$runmean==1} {set result($item) [running_mean $result($item) $a]}
     if {$autocorr==1} {

          set file  $pwd/.moviefile
          set wid [open $file w]
            puts $wid $item
          foreach thing  $result($item) {
             puts $wid $thing
          }
          close $wid

          set len [llength $result($item)]
          set result($item) [eval exec $moviehome/../cprog/cross_correlate $file $file]
          file delete $file
       }

#     if {$stepmean==1} {set result($item) [step_calc $result($item) $a mean]}
#     if {$stepsum ==1} {set result($item) [step_calc $result($item) $a sum]}
  }
}
if [winfo exists .map] {mapview}
}




