# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc makeselector {} {
global DOS
global can
global varlist boxlist nicevarlist
global comvarlist comboxlist
global varrem boxrem
global boxwin varwin
global newset newgraph
global toolflag
global filename
global casesensitive
global boxFont
global varbut boxbut var_butwid_extra box_butwid_extra
global buttoncolor
global moviehome
global nicevar
global bc boxslid nicevar
global maxfiles

for {set i 1} {$i <= $maxfiles} {incr i} {set f($i) 0}
if ![info exist boxslid] {set boxslid 0}
# neu(!!!!): Auswertung, ob Schnittmengenbildung erforderlich ist (für cpmpare, text, profcom)
set intersect 0
if {$toolflag=="compare" || $toolflag=="text" || $toolflag=="profcom"} {set intersect 1} 

set comvarlist {}
# Fuer MAC OS ($DOS==2) ist es erforderlich, die Buttons breiter zu machen als unter Linux und Windows(Cygwin)
set var_butwid_extra 0
set box_butwid_extra 0

if {$DOS==2} {
   set var_butwid_extra 2
   set box_butwid_extra 3
}

# Falls sich das Resultfile während MoViE-Session geaendert hat
ReadFile $filename(1) 1

if {$casesensitive==1} {
   foreach item $varlist(1) {
	 if ($intersect==1) {  
       for {set i 2} {$i <= $maxfiles} {incr i} {
         if [info exists filename($i)] {set f($i) [lsearch -exact $varlist($i) $item]}
       }
       for {set i 2} {$i <= $maxfiles} {incr i} { if {$f($i) == -1} {set f(1) -1}}
     }
     if { $f(1)!=-1 } {lappend comvarlist $item} else {set f(1) 0}
   } 
} else {
   foreach item $varlist(1) {
	 if ($intersect==1) {  
       for {set i 2} {$i <= $maxfiles} {incr i} {
           if [info exists filename($i)] {set f($i) [lsearch -exact $varlist($i) [string tolower $item]]}
#puts "$filename($i) i=$i f(i)=$f($i),$item"
       }
       for {set i 2} {$i <= $maxfiles} {incr i} { if {$f($i) == -1} {set f(1) -1}}
     }
     if { $f(1)!=-1 } {lappend comvarlist [string tolower $item]} else {set f(1) 0}
   }
}

for {set i 1} {$i <= $maxfiles} {incr i} {set f($i) 0}

set comboxlist {}

foreach item $boxlist(1) {
  if ($intersect==1) {  
   for {set i 2} {$i <= $maxfiles} {incr i} {
         if [info exists filename($i)] {set f($i) [lsearch -exact $boxlist($i) $item]}
   }
   for {set i 2} {$i <= $maxfiles} {incr i} { if {$f($i) == -1} {set f(1) -1}}
  } 
   if { $f(1)!=-1 } {lappend comboxlist $item}  else {set f(1) 0}
} 

if {$comvarlist != {} && $comboxlist != {} } {
   set varrem [lindex $comvarlist 0]
   set boxrem [lindex $comboxlist 0]
} else {
   textinfo "No common variables found!" 1
   $bc.load configure -state normal
   update idletasks
#   killwin
#   .ov.right.button.view configure -state disabled
   return
}

if {$nicevar==1 } {nicevarselector} else {var_selector}	
if {$boxslid==1 } {boxslider} else {box_selector}

if {$nicevar==1} {nicevarselector}
if {$toolflag == "film" || $toolflag == "profile" ||$toolflag== "profcom" || $toolflag== "contour"} {makecommand -1 -1}
update idletasks
}

