# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc MakeVarBox { all a} {
global varlist
global boxlist
global casesensitive
set varlist($a) ""
set boxlist($a) ""

regsub -all {[(][0-9]+[)]} $all " " varlist($a)
#regsub -all {[A-Za-z0-9]+[(]} $all " " abox
regsub -all {[A-Za-z0-9_]+[(]} $all " " abox
regsub -all {[)]} $abox " " boxlist($a)



if {$casesensitive==0} {set varlist($a) [string tolower $varlist($a)]}

set varlist($a) [lsort -ascii $varlist($a)]
set boxlist($a) [lsort -integer $boxlist($a)]



# Filter for double names and boxes

set dummy [lindex $varlist($a) 0]
for {set i 1} {$i< [llength $varlist($a)]} { incr i} {
   if {[lindex $varlist($a) [expr $i-1]] != [lindex $varlist($a) $i]} {
       lappend  dummy [lindex $varlist($a) $i]
   }
}
set varlist($a) $dummy

set dummy [lindex $boxlist($a) 0]
for {set i 1} {$i< [llength $boxlist($a)]} { incr i} {
   if {[lindex $boxlist($a) [expr $i-1]] != [lindex $boxlist($a) $i]} {
       lappend  dummy [lindex $boxlist($a) $i]
   }
}
set boxlist($a) $dummy



}

