# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc angleslider {i} {
global can xangle zangle
# Box Slider
#-------------
if ![info exist xangle] {set xangle 30}
if ![info exist zangle] {set zangle 60}

if ![winfo exists .as] {
  toplevel .as

  wm title .as {Gnuplot Control}
  wm geometry .as "+[expr $can +100]+[expr $can-10]"
  wm attributes .as -topmost yes
  wm protocol .as WM_DELETE_WINDOW {angleslider 0}

  
  scale .as.x -length 300 \
      -from 0 -to 90\
      -variable xangle \
      -orient horizontal \
      -tickinterval 10 \
      -showvalue true \
      -resolution 1 \
      -bigincrement 10
  pack .as.x -fill x
  bind .as.x <ButtonRelease-1> "make_gnucmd_phase $i"
  
  scale .as.y -length 300 \
      -from 0 -to 90\
      -variable zangle \
      -orient horizontal \
      -tickinterval 10 \
      -showvalue true \
      -resolution 1 \
      -bigincrement 10
  pack .as.y -fill x
  bind .as.y <ButtonRelease-1> "make_gnucmd_phase $i"
}
make_gnucmd_phase $i
}

proc Stopgnuplot {} {
	global pwd

        set gnupid [exec checkproc -v gnuplot_x11 ]
	exec kill -9 $gnupid
}

