# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc execlog { } {
global input log textFont

# Create a text widget to log the output
frame .prepare.prepare
set log [text .prepare.prepare.log -width 80 -height 15 \
	-borderwidth 2 -relief raised -setgrid true -font $textFont \
	-yscrollcommand {.prepare.prepare.scroll set}]
scrollbar .prepare.prepare.scroll -command {.prepare.prepare.log yview}
pack .prepare.prepare.scroll -side right -fill y
pack .prepare.prepare.log -side left -fill both -expand true -padx 5 -pady {0 5}
#pack .prepare.prepare -side top -fill both -expand true
pack .prepare.prepare -side left

}


# Run the program and arrange to read its input
proc Run {} {

global prep_command input log allbuts pbg pwd

# $log delete 1.0 end
if {$pbg==0} {
deactivate $allbuts
. config -cursor watch
update

if [catch {open "|$prep_command |& cat"} input] {
  $log insert end $input\n
} else {
  fileevent $input readable Log
  #$log insert end $prep_command\n
}

} else {
$log insert end "Running in background"
puts $prep_command
#exec nohup $prep_command > $pwd/prepare.log &

catch {open "|nohup $prep_command > $pwd/prepare.log &"}
}
}


# Read and log output from the program
proc Log {} {
	global input log allbuts par
	if [eof $input] {
	    Stop
        activate $allbuts
	    . config -cursor top_left_arrow
	} else {
		gets $input line
		$log insert end $line\n
		$log see end
	}

}

# Stop the program and fix up the button
proc Stop {} {
	global input
	catch {close $input}
}

