# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc makediff {i method} {
global file1 file2 pwd log moviehome prep_command

wm attributes .prepare -topmost no
set filename [fileselect  "Select result file" outc $pwd open]

if {$i==1} {$log delete 1.0 end}
$log insert end "File $i: $filename \n"

set ext [file extension $filename]
#regsub $ext $filename $ext file$i
#set file$i [file rootname $filename]
set file$i $filename

if {$i==1} {

  if {$file1 != ""} {.prepare.right.diff.sf configure -state normal}

} else {

  if {$file2!=""} {

    $log insert end "\n"
      set prep_command "$moviehome/../cprog/analyse_result $file1 $file2 $method"
    #set prep_command "$moviehome/../cprog/compare_result $file1 $file2 $method"

    Run
    unset file1
    unset file2
    .prepare.right.diff.sf configure -state disabled
  } else {
    $log insert end "Missing filename !! \n"
  }
}
wm attributes .prepare -topmost yes
}

