# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc makemcsv {in out} {

set  id [open $in r]

while {[gets $id line] != -1} {
if [string match #* $line] {
  # preserve header lines
  puts $wid $line
} else {
  # getting rows as list
  lappend rows [split [string map {" " ""} $line]  ",:"]
}
}
close $id


set wid [open $out w]
set rowlen [llength [lindex $rows 0]]
# transpose
for {set k 0} {$k<[llength $rows]} {incr k} {
   for {set j 0} {$j<$rowlen} {incr j} {
     lappend newrow($j) [lindex [lindex $rows $k] $j]
    }
}
for {set j 0} {$j<$rowlen} {incr j} {
    # transforming list to comma separated

    puts $wid [join $newrow($j) ", "]
}
close $wid

}

