# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc makesymb {in out} {

set  id [open $in r]

while {[gets $id line] != -1} {
if [string match #* $line] {
  # preserve header lines
  puts $wid $line
} else {
  # getting rows as list
  lappend rows [split [string map {" " ""} $line]  ","]
}
}
close $id


set wid [open $out w]
set rowlen [llength [lindex $rows 0]]

# nullte Liste in rows sind die Header ohne :
# transpose
for {set k 1} {$k<[expr [llength $rows]]} {incr k} {
   for {set j 0} {$j<$rowlen} {incr j} {
     lappend newrow($j) [lindex [lindex $rows $k] $j]
    }
}
for {set j 0} {$j<$rowlen} {incr j} {
    # transforming list to comma separated

    puts $wid [lindex [lindex $rows 0] $j]:[join $newrow($j) ", "]
}
close $wid

}

