/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#ifndef _TYPES_
#define _TYPES_ 
#include <math.h>

#ifndef __PREPARE__
#include "precision.h"
#include "compiler_setup.h"
#endif


#ifndef __SHARE_MEM__
#include "shared_mem.h"
#endif

/* Definition von Werten fuer numerische Ueberpruefungen */
/*#define MIN_FLOAT 2.0e-38F
#define MAX_FLOAT 3.2e+38F*/

/* Definitionen fuer Auswertung von Zeitreihen (rechte oder linke Grenze eines Zeitintervalls) */
#define __LEFTSLOPE -1
#define __RIGHTSLOPE 1

/* Konstanten und Typen fuer standardisierte Strings */
#define __namelength 80
typedef char name[__namelength+1];
typedef char string[512];
typedef char long_name[__namelength];

#endif
