/***********************************************************************
**                                                                    **
** CEMoS Version 4.1.2 Copyright(C) 2023 Frank Hamberg, Cora Kohlmeier**
**                                                                    **
***********************************************************************/
#include "stdinc.h"
#include "constructs.h"
#include "prepare.h"

/*
2008-10-12:
Funktionstyp auf int geändert.
Return-Wert ist die Anzahl der gesetzten Flags.
Verwendung in read_start_1D zur Verhinderung von Feldgrenzenüberschreitungen
*/

int set_flags(char *list,int *flags)
{
int bp1,bp2,i,cp,counter=0;
char *input,*inlist,komma[2];

input=(char *) malloc(_BUFSIZE_*sizeof(char));
inlist=(char *) malloc(_BUFSIZE_*sizeof(char));
sprintf(komma,"%s",",");

sprintf(inlist,"%s",list);

while (strlen(inlist)>0)
    {
    cp=strpos(inlist,komma);
    if (cp>0)
     {
     sprintf(input,"%s",strmid(inlist,0,cp));
     sprintf(inlist,"%s",strmid(inlist,cp+1,(int) strlen(inlist)-cp-1));
     }
    else
     {
     sprintf(input,"%s",inlist);
     sprintf(inlist,"%s","");
     }
     cp=strpos(input,"-");
     if (cp>0)
     {
     sscanf(strmid(input,0,cp),"%d",&bp1);
     sscanf(strmid(input,cp+1,(int) strlen(input)-cp-1),"%d",&bp2);
     sprintf(input,"%s","");

     for (i=bp1;i<=bp2;i++) 
        {
          flags[i]=1;
          counter++;
        }
     }
     else
     {
     sscanf(input,"%d",&bp1);
     flags[bp1]=1;
     counter++;
     }
    }
free(input);
free(inlist);
return(counter);
}

