# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg

#########################################
# called from customtool
#########################################
proc cev_writedefaults {} {
global home pwd
global sfont lfont
global defaulteditor simtype colorscheme


set id [open $home/.cev5defaults w+]

if ![info exist colorscheme]  {set colorscheme classic}
if ![info exist defaulteditor] {set defaulteditor "\"\""}

puts $id "set defaulteditor $defaulteditor"
puts $id "set sfont [list $sfont]"
puts $id "set lfont [list $lfont]"
puts $id "set simtype $simtype"
puts $id "set colorscheme $colorscheme"

close $id
}

proc cev_readdefaults {} {
global home pwd DOS colorscheme
global sfont lfont
global editor defaulteditor simtype

set sheight [winfo screenheight .]

set sfont "-size 11"
set lfont "-size 11"

set simtype outc

set defaulteditor  ""

set file $home/.cev5defaults

if [file exists $file] {
   set id [open $file r]
   while {[gets $id line] >=0} {
    eval $line
   }
   close $id 
}
   
if {$defaulteditor==""} {
   switch $DOS {
   0 { set editor "kwrite"}
   1 { set editor "c:/programme/zubeh�/wordpad.exe"}
   2 { set editor "open -e "}
   default {set editor ""}
   }
} else {
  set editor $defaulteditor
}
cev_writedefaults
}
