# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
#--------------------
# Select cev Parameter file
#--------------------
proc cev_gui_select_cev {} {
global lfont cev_file pwd browsedir

.topp.filo.info.info1.cevs config -state disabled

toplevel .cev
wm title .cev {Select CEV File}
wm geometry .cev "+270+270"
wm protocol .cev  WM_DELETE_WINDOW {cancelcev}
wm attributes .cev -topmost yes

frame .cev.up
pack .cev.up
   
set browsedir $pwd/cevos

set sourcename "$browsedir/cevos.cev"

entry .cev.up.text -width 50 -textvariable cev_file -font $lfont
pack .cev.up.text -side left

button .cev.up.choose -font $lfont -text {Browse}\
       -command {set cev_file [fileselect "CEV file" "cev" $browsedir open];if [winfo exist .cev] { raise .cev}}
pack .cev.up.choose -side left

frame .cev.but
pack .cev.but

button .cev.but.cancel -font $lfont -text {cancel} -command {cancelcev}
pack .cev.but.cancel -side left

button .cev.but.close -font $lfont -text {ok} -command {OKcev}
pack .cev.but.close -side left
}

proc OKcev {} {
global cev_file
put "Selected $cev_file as CEV-File for settings"
.topp.filo.info.info1.cevs config -state normal
.topp.filo.info.info1.cev config -text "$cev_file"

destroy .cev
destroy .par     
cev_readpar $cev_file
cev_gui_make_par_window
}

proc cancelcev {} {
.topp.filo.info.info1.cevs config -state normal
destroy .cev
}

