# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
#--------------------
# Random Batch
#--------------------

proc cev_make_random_batch {} {
global cevvar cevvalfrom cevval   cevvalto cevvarnum cev_resultdir actcevval
global batname cevvalrem
global pwd  cev_resultdir
global posval
global active changecounter groupchange 
global maxruns maxsteps
global init rndchange
global GUI
global parwin

# Bevor zufaellige Variation eines Parameters losgeht
switch $init {
      0 {
              # keeping actual parameter values
                for {set i 0} {$i<=$cevvarnum} {incr i} {
                        set cevval($i) $actcevval($i)
                }

         }
      1 {
              # setzen der besten Werte
              # cev_reset_tobest
              cev_read_bestpar

          } 
      2 {
              #neu initialisieren auf Werte in der cevos.cev
               puts "New initializing ..."

                for {set i 0} {$i<=$cevvarnum} {incr i} {
                        set cevval($i) $cevvalrem($i)
             }
         } 
}
# Farbe zuruecksetzen
if {$GUI==1} {
 for {set i 0} {$i<=$cevvarnum} {incr i} {
	 $parwin.c.scrolled.out.f$i.ll$i config -fg black
     $parwin.c.scrolled.out.f$i.ew$i config -fg black
	 }   
}

# Auswahl eines Parameters zur Variation

if {$groupchange==0} {
# Auswahl eines einzelnen Parameters zur Variation
        for {set i 0} {$i<=$cevvarnum} {incr i} {set on($i) 0}
        set change 0

        while {$change==0} {
                set rndpar -1


                while {$rndpar <0} { set rndpar [expr int(floor(($cevvarnum+1)*[cev_random]-.000001))  ]}

                if {$active($rndpar)==1} {
                        if {$GUI==1} { $parwin.c.scrolled.out.f$rndpar.ll$rndpar config -fg red; \
									   $parwin.c.scrolled.out.f$rndpar.ew$rndpar config -fg red
							}
                        set on($rndpar) 1
                        set change 1
                }
        }
} else {
# Alle aktiven Parameter zur Variation freigeben
        for {set i 0} {$i<=$cevvarnum} {incr i} {set on($i) $active($i)}
}
# global sum
# incr sum($rndpar) 
# puts "$rndpar $sum($rndpar)"
set execute 0
while {$execute==0} {
        set execute 1
        set parlist ""
        for {set i 0} {$i<=$cevvarnum} {incr i} {
                if {$on($i)==1} {
                # Parameter mit der Nummer $i wird verändert
                        if {$cevval($i)!=0} {
                                set actrnd [cev_random] 
                                set actcevval($i) [expr $cevval($i)*(1.0+$rndchange*($actrnd - 0.5))]
                        } else {
                                if {$posval==1} {
                                set actcevval($i) [cev_random] 
                                } else {
                                set actcevval($i) [expr ([cev_random] - 0.5)]
                                }
                        }
                
                # nur positive Werte nehmen
                        if {$posval==1 && $actcevval($i)<0} {
                             set actcevval($i) [max 0 $cevval($i)]
                             set execute 0
                        }
                
                        if {$cevvalfrom($i)!=$cevvalto($i)} {
                                if {$actcevval($i)<$cevvalfrom($i) || $actcevval($i)>$cevvalto($i) } {
                #                                set actcevval($i) [expr  ($cevvalfrom($i)+$cevvalto($i))/2.0 ]
                                                set actcevval($i) $cevvalrem($i)
                                                #puts "$cevvar($i) $cevvalfrom($i) $actcevval($i) $cevvalto($i) "
                                                set execute 0
                                }
                        }
                
                } else {
                # alle anderen werden nicht veraendert
                        set actcevval($i) $cevval($i)
                }
                # Liste der Parameter mit ihren Werten zusammenbauen
                append parlist "$cevvar($i)=$actcevval($i);"
        }
}        

set batname $cev_resultdir/sensitivity.bat
set wid [open $batname w]
#puts $parlist
puts $wid $parlist
close $wid
} 
