# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
# Procedure example
proc cev_randomInit { seed } {
	global rand
	set rand(ia) 9301	;# Multiplier
	set rand(ic) 49297	;# Constant
	set rand(im) 233280	;# Divisor
	set rand(seed) $seed	;# Last result
}
proc cev_random {} {
	global rand
	set rand(seed) \
		[expr ($rand(seed)*$rand(ia) + \
				 $rand(ic)) % $rand(im)]
	return [expr $rand(seed)/double($rand(im))]
}
proc cev_randomRange { range } {
	expr int([cev_random]*$range)	
}
