# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
#--------------------

#--------------------
proc cev_write_best {which resultname bestdist absbestdist} {
# which = best oder absbest
# file = aktuelle simulation
# dist =aktuelle distanz
global counter changecounter broken 
global cev_resultdir  
global difftype
global cevvar actcevval cevvarnum

# aktuelle counter lesen
if [file exist $cev_resultdir/count.dat] {
 cev_read_count
}

# dist-file schreiben
set wid [open $cev_resultdir/$which.dist w]

puts $wid "set bestdist $bestdist"
puts $wid "set absbestdist $absbestdist"
puts $wid "set difftype $difftype"
puts $wid "set counter $counter"
puts $wid "set changecounter $changecounter"
puts $wid "set broken $broken"
close $wid

# batch-File schreiben
set wid [open $cev_resultdir/$which.bat w]
set out ""
for {set i 0} {$i<=$cevvarnum} {incr i} {
        append out "$cevvar($i)=$actcevval($i);"
}
puts $wid $out
close $wid


# cin-File schreiben
set wid [open $cev_resultdir/$which.cin w]
puts $wid \%change
puts $wid "// Distance type= $difftype  Distance= $bestdist Number of runs= $counter Number since last change= $changecounter Number broken runs= $broken\n"

for {set i 0} {$i<=$cevvarnum} {incr i} {
        puts $wid "$cevvar($i)=$actcevval($i);"
}
close $wid

# Resultfile (outc _pk.outc,info,log, dist  umkopieren zu best bzw absbest)
if [file exist $resultname] { file copy -force $resultname $cev_resultdir/$which.outc}
if [file exist [file rootname $resultname]_pk.outc] { file copy -force [file rootname $resultname]_pk.outc $cev_resultdir/$which\_pk.outc}
if [file exist [file rootname $resultname].log] {file copy -force [file rootname $resultname].log  $cev_resultdir/$which.log}
if [file exist  [file rootname $resultname].info] {file copy -force [file rootname $resultname].info  $cev_resultdir/$which.info}
if [file exist  [file rootname $resultname].dist] {file copy -force [file rootname $resultname].dist  $cev_resultdir/$which.dist}

}


