/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */
#include "stdinc.h"

real average(real *in_vector,int start_ind, int end_ind)
{
/* Input :  real *in_vector		Pointer to input vector dimension vec_len

   Output: real average
*/
int i;
int vec_len;
real vec_avg,a;

vec_len      = end_ind - start_ind +1;
if (vec_len  < 1) std_error("STDDEV: Input vector has zero length");

vec_avg = (real) 0.0;

for (i=start_ind; i<=end_ind; i++)
    {
    a = in_vector[i];
    vec_avg += a;
    }

vec_avg /= (real) vec_len;

return(vec_avg);
}

