# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc fileselect {title type dir operation {name MOVIECOMMAND}} {
global lfont


switch $type {
outa { set types {
        {"Result files" {.outa} }
        {"All files"            *}
       }
     }
     
outb { set types {
        {"Result files" {.outb} }
        {"All files"            *}
       }
     }

outc { set types {
        {"Result files" {.outc} }
        {"All files"            *}
       }
     }

nc { set types {
	{"Result files"	{.nc}	}
	{"All files"		*}
       }
     }

mcf  { set types {
	{"Movie Command files"	{.mcf}}
	{"All files"		*}
       }   
     }

symb { set types {
	{"Data files"	{.symb}	}
	{"All files"		*}
     }
       }   


c    { set types {
	{"C Source Files"	{.c}}
	{"All files"		*}
       }   
     }

def  { set types {
	{"Parameter Files"	{.def}}
	{"All files"		*}
       }   
     }

log  { set types {
	{"Log Files"	{.log}}
	{"All files"		*}
       }   
     }

bat  { set types {
	{"Batch "	{.bat }} 
	{"All files"		*}
       }
     }

cin  { set types {
	{" Run Files"	{ .cin}} 
	{"All files"		*}
       }
     }

cev  { set types {
	{"cev Files"	{ .cev}} 
	{"All files"		*}
       }
     }

none { set types {
	{"All files"		*}
       }
     }

default { set types {
	   {"All files"		*}
	   {"Movie Command files"	{.mcf}}
	   {"Tcl Scripts"		{.tcl}}
	   {"C Source Files"	{.c .h}}
	   {"Parameter Files"	{.def}}
	   {"Log Files"	{.log}}
        }   
    }
}

global tk_strictMotif
set tk_strictMotif 0
    if {$operation == "open"} {
	set file [tk_getOpenFile -title $title -filetypes $types  -initialdir $dir]
    } else {
	set file [tk_getSaveFile -filetypes $types -title $title  -initialfile $name -defaultextension $type]
    }
return $file

}
