# CEMOS/CEMTK 5.0 Copyright(C) 2022 Cora Kohlmeier, Frank Hamberg
proc make_generalflags {} {
global gflagarr
global general_flaglist

set flags ""
foreach item $general_flaglist {
#gsl is a linked library
  if {$item!="gsl"} {
     if {$gflagarr($item)==1} {lappend flags -$item }
  }
}

put "General compile flags:  $flags"
return $flags
}


proc make_compileflags {} {
global cflagarr
global compile_flaglist DOS

set flags ""
foreach item $compile_flaglist {
  if {$cflagarr($item)==1} {lappend flags -$item }
}

put "Model compile flags:  $flags"
return $flags
}

proc make_linkflags {} {
global gflagarr
global cflagarr DOS

set flags "-lnetcdf" 
if {$DOS == 0} {
   if {$gflagarr(pg)==1 && $gflagarr(static) } {lappend flags -pg -static-libgcc }
   if {$gflagarr(efence)==1} {lappend flags "-lefence"} 
   if {$gflagarr(gsl)==1} {lappend flags "-lgsl -lgslcblas"} 
}
#  if {$cflagarr(fopenmp)==1} {lappend flags -lgomp}
#if {$gflagarr(m32)==1} {lappend flags -m32 }


put "Link flags:  $flags"
return $flags
}

