/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */

#include "stdinc.h"

void writeheader(FILE *unit, header *oh, long_name80 *names, int namelength)
{
  fwrite(&oh->nvars,sizeof(unsigned int),1,unit);
  fwrite(&oh->startim,sizeof(float),1,unit);
  fwrite(&oh->endtim,sizeof(float),1,unit);
  fwrite(&oh->maxdelt,sizeof(float),1,unit);
  fwrite(&oh->outdelt,sizeof(float),1,unit);
  fwrite(&oh->year,sizeof(float),1,unit);
  fwrite(&oh->cycle,sizeof(float),1,unit);
  fwrite(oh->sdir,sizeof(char),namelength,unit);

  fwrite(names,namelength*oh->nvars,1,unit);
  return;
}


