/* MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */
// # C. Kohlmeier 121218
// 
// # shifted resultfile zu anderer Startzeit
// # zB um bei 10y runs das letzte Jahr von Tag 1 zu speichern

#include "stdinc.h"

int main(int argc, char *argv[])
{
void *readheader(FILE*,header*,int);
void writeheader(FILE *, header*, long_name80*, int);
 
header oh;
char *resultname;
char *var;

string input_file,output_file;
 long int timnum;

int i;
float *dat;
FILE *unit;
FILE *wunit;
float newstart,days;
int namelength;
long_name80 *all_var_names;


namelength = sizeof(long_name);

resultname=argv[1];
sscanf(argv[2],"%f",&newstart);

sprintf(input_file,"%s.outc",resultname);
sprintf(output_file,"%s_shift.outc",resultname);
 
unit=fopen(input_file,"rb");
wunit=fopen(output_file,"wb");
namelength = sizeof(long_name80);
  
 if (unit != NULL)
 {    
   namelength = sizeof(long_name80);
   
   all_var_names = readheader(unit,&oh,namelength);
   
   days=oh.endtim-oh.startim;
   oh.startim=(float) newstart;
   oh.endtim=(float) (newstart+ days);
     
/*  Header schreiben*/
  writeheader(wunit,&oh,all_var_names,namelength);
     timnum = (long int)(1.+(oh.endtim-oh.startim)/oh.outdelt);
   
   dat = malloc(sizeof(float)*oh.nvars* timnum);   
   fread(dat,sizeof(float),oh.nvars* timnum,unit);
   fwrite(dat,sizeof(float),oh.nvars* timnum,wunit);

   
  fclose(unit);
  fflush(wunit);
  fclose(wunit);
 }
else
  printf("Error in shiftresult \n");

return(0);
}


