# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc control_bindings {} {
global pwd toolflag
global ovc


#Nicevarselector
bind $ovc <3> {
   if [winfo exist .vs] {
       if [winfo ismapped .vs] {
            if ![winfo exist .nvs] {nicevarselector}
       } else {
            wm deiconify .vs
            if [winfo exist .nvs] {destroy .nvs}
       }
   }
}

#Niceboxselector
if {$toolflag=="overview" || $toolflag=="compare" || $toolflag=="text" || $toolflag=="phase"} {
bind $ovc <2> {
   if [winfo exist .bs] {
       if [winfo ismapped .bs] {
            wm withdraw .bs
            if ![winfo exist .ts] {
              if [file exist $pwd/map.info] {
	       niceboxselector
	      } else {
	       makeboxslider
	      }
	    }
       } else {
            wm deiconify .bs
            if [winfo exist .ts] {destroy .ts}
       }
    }
}
}

#Scrollable Selector
bind $ovc <Shift-3> {
   if [winfo exist .vs] {destroy .vs}
   if [winfo exist .bs] {destroy .bs}
   if [winfo exist .ts] {destroy .ts}
   makeselector
}



global controlpack
if ![info exist controlpack] {set controlpack bottom}
bind $ovc <Shift-1> {
  if {$controlpack=="bottom"} {
     if [winfo exist $ovc.left.set] {pack $ovc.left.set  -side left;set controlpack left}
  } else {
     if [winfo exist $ovc.left.set] {pack $ovc.left.set  -side bottom;set controlpack bottom}
  } 


}



}
