# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc initmapview { } {
global canvas
global mapcan can

if [winfo exists .ts] {destroy .ts}

toplevel .ts

wm title .ts {Map }
wm geometry .ts "+0+[expr $can+30]"
wm group .ts .
wm transient .ts .

set canvas .ts.top.plot
set mapcan 400

frame .ts.top
pack .ts.top -side top -fill x

canvas .ts.top.plot -width $mapcan -height $mapcan
pack .ts.top.plot -side left

}

proc mapview {} {
global pxmin pxmax pymin pymax pxdelt pydelt
global ymin ymax ydelt
global mapcan
global mapname
global layer

set layer upper

if [info exist ymin] {unset ymin}
if [info exist ymax] {unset ymax}
if [info exist ydelt] {unset ydelt}

set pxmin 10
set pxmax [expr $mapcan - 10]
set pymin [expr $mapcan - 10]
set pymax 10

set pxdelt [expr $pxmax -$pxmin]
set pydelt [expr $pymax -$pymin]

switch $mapname {
  map15 {map15}
  map130 {map130}
  mapcocoa {mapcocoa}
  map4 {map4}
  map5 {map5;extract_one_tracer}
  map8 {map8}
  mapecotim {mapecotim}
  mapecotim2 {mapecotim2}
}

if [info exist ymin] {unset ymin}
if [info exist ymax] {unset ymax}
if [info exist ydelt] {unset ydelt}

initplot

}


