# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc set_plotcolors {} {
global colorlist plotcolorlist movplotcols canvascolor

set movplotcols {classic parula lines prism colcube}

switch $plotcolorlist {
	classic {
			set colorlist {black red3 darkgreen darkblue gold3 purple cyan  magenta limegreen lightblue darkgreen}
			append colorlist " $colorlist"
			set canvascolor #f0f0f0
			}
    parula  { 
			set colorlist {"#0072BD" "#D95319" "#EDB120" "#7E2F8E" "#77AC30" "#4DBEEE" "#A2142F" "#23A1E4" "#15AFD9" "#01BAC4" "#25C2AD" "#3AC993" "#61CD71" "#91CA4C" "#BEC32E" "#E4BB2C" "#CEBE3C" "#CBD22F" "#C5E725" "#A9FB15"}
			set canvascolor #e8e8e8
			}

    prism 	{ 
			set colorlist {"#FF0000" "#FF8000" "#FFFF00" "#00FF00" "#0000FF" "#AA00FF" "#FF0000" "#FF8000" "#FFFF00" "#00FF00" "#0000FF" "#AA00FF" "#FF0000" "#FF8000" "#FFFF00" "#00FF00" "#0000FF" "#AA00FF" "#FF0000" "#FF8000"}
			set canvascolor #a0a0a0
			}
    
    colcube { 
			set colorlist {"#404000" "#00FFFF" "#FF00FF" "#400000" "#800000" "#BF0000" "#FF0000" "#004000" "#008000" "#00BF00" "#00FF00" "#000040" "#000080" "#0000BF" "#0000FF" "#000000" "#404040" "#808080" "#BFBFBF" "#9F9F9F"}
			set canvascolor #c0c0c0
			}
    
    lines 	{
			set colorlist {"#0072BD" "#D95319" "#EDB120" "#7E2F8E" "#77AC30" "#4DBEEE" "#A2142F" "#0072BD" "#D95319" "#EDB120" "#7E2F8E" "#77AC30" "#4DBEEE" "#A2142F" "#0072BD" "#D95319" "#EDB120" "#7E2F8E" "#77AC30" "#4DBEEE"}
			set canvascolor #e8e8e8
			}    

    default {
			set colorlist {"#0072BD" "#D95319" "#EDB120" "#7E2F8E" "#77AC30" "#4DBEEE" "#A2142F" "#0072BD" "#D95319" "#EDB120" "#7E2F8E" "#77AC30" "#4DBEEE" "#A2142F" "#0072BD" "#D95319" "#EDB120" "#7E2F8E" "#77AC30" "#4DBEEE"}
			set canvascolor #e8e8e8
			}    

}
} 
