# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc mapcocoa {} {
global map
global can
global moviehome
global xmin xmax ymin ymax xdelt ydelt
global upper lower obj actbox numpos
global mapname
global pxmin pxmax pymin pymax pxdelt pydelt

set mapname mapcocoa


if [info exists map] {unset map}

# set pxmin 80
# set pxmax [expr $can - 30]
# set pymin [expr $can - 30]
# set pymax 50
# set pxdelt [expr $pxmax -$pxmin]
# set pydelt [expr $pymax -$pymin]

set xmin -4
set xmax 9
set xdelt [expr $xmax -$xmin]

set ymin 50
set ymax 62
set ydelt [expr $ymax -$ymin]
set actbox 93
set obj rect

set upper {1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24
          25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40
          41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56
          57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74
          75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 }

set lower {94 95 96 97 98 99 100 101 102 103 104 105 106 107
          108 109 110 111 112 113 114 115 116 117
          25 26 27 118 119 120 121 122 123 124 125 126 127 128 129 130
          131 132 133 44 45 46 134 48 49 50 135 52 53 54 136 137 138 58 59 60
          61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80
          81 82 83 84 85 86 87 88 89 90 91 92 93}


set i 1
set id [open $moviehome/film/mapcocoa/cocoa.dat r]
   while {[gets $id line] >=0} {
    set zeile($i) $line
    incr i
   }
close $id

for {set i 0} {$i<=93} {incr i} {
     lappend map($i) [expr int([nnx [lindex $zeile(1) $i]])]
     lappend map($i) [expr int([nny [lindex $zeile(7) $i]])]
     lappend map($i) [expr int([nnx [lindex $zeile(2) $i]])]
     lappend map($i) [expr int([nny [lindex $zeile(8) $i]])]

      # puts "$i   [lindex $zeile(1) $i] [lindex $zeile(2) $i] [lindex $zeile(7) $i] [lindex $zeile(8) $i]"
   }

for {set i 1} {$i <= 93} {incr i} {
   set x1 [lindex $map($i) 0]
   set y1 [lindex $map($i) 1]
   set x2 [lindex $map($i) 2]
   set y2 [lindex $map($i) 3]
   

 
   set x [expr ($x1+$x2)/2.0]
   set y [expr ($y1+$y2)/2.0]

   set numpos($i) "$x $y"
}


createboxes
geomap_ersem
}

