# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc mapecotim2 {} {
global map
global can moviehome

global xmin xmax ymin ymax xdelt ydelt
global upper lower obj actbox numpos
global mapname

set mapname mapecotim2

if [info exists map] {unset map}
global pxmin pxmax pymin pymax pxdelt pydelt


# 
# set pxmin 30
# set pxmax [expr $can - 30]
# set pymin [expr $can - 150]
# set pymax 50
#  
# set pxdelt [expr $pxmax -$pxmin]
# set pydelt [expr $pymax -$pymin]

set xmin 120
set xmax 265

set xdelt [expr $xmax -$xmin]

set ymin  10
set ymax 88
set ydelt [expr $ymax -$ymin]


set upper {1 2 3 4 5 6 7 8 9 10 11 12 13 14}
set lower {1 2 3 4 5 6 7 8 9 10 11 12 13 14}

set actbox 14
set obj poly

set wid [open "$moviehome/film/mapecotim2/mapecotim2.dat" r]

for {set i 1} {$i<=14} {incr i} {
 set co($i) [gets $wid]
}

close $wid

set wid [open "$moviehome/film/mapecotim2/numecotim2.dat" r]
set num [gets $wid]
close $wid

set num [scalepolygon $num]

for {set i 1} {$i <= 14} {incr i} {
   set x [lindex $num [expr 2*($i-1)]]
   set y [lindex $num [expr 2*($i-1)+1]]

   set numpos($i) "$x $y"
}

foreach i $upper {
   set map($i) [scalepolygon $co($i)]
}

createboxes
geomap_ecotim2



}


