# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc macraise {} {
global DOS
# auf MAC-OS gibt es im single-window mode den Effekt, dass das Fenster transparent erscheint und erst nach Mausklick außerhalb aktiv wird
# oder dass das Fenster nicht aktualisiert (z.B. Film-Tool nach Variablenwechsel und Apply)
# dazu nun dies.
# Ablauf:
# Mausposition mit Bezug auf die Position des Hauptfensters und der "Decoration" merken 
if {$DOS==2} {
	set ox [expr [winfo pointerx .] - [winfo x .]]
	set oy [expr [winfo pointery .] - [winfo y .] -25]
	# Maus nach links außerhalb bewegen
	event generate . <Motion> -x -1000 -y 500 -warp 1
	after 10
	# Mausbutton drücken
	event generate . <ButtonPress-1>
	after 10
	# nach 10 Millisekunden loslassen
	event generate . <ButtonRelease-1>
	update
	update idletasks
	after 10
	# und nach 10 Millisekunden wieder zurück auf alte Position
	event generate . <Motion> -x $ox -y $oy -warp 1
}
}
