# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc myplot {c plotdata width color sm graph} {

global DOS
  # technische Begrenzung bei tickle for windows
  # fuer create line bei ungefaehr 15000 Datenpunkten

  if {$DOS==0} {
      
      set item [eval $c create line $plotdata -width $width -fill $color -smooth $sm]

      $c addtag $color$graph withtag $item
      $c addtag $graph withtag $item
  
  } else {

   set len [llength $plotdata]
   set anf 0
   set end [min $len 15001]

   while {$anf < [expr $end-1]}  {

      set pd [lrange $plotdata $anf $end]

      set item [eval $c create line $pd -width 1 -fill $color -smooth $sm]

      $c addtag $color$graph withtag $item
      $c addtag $graph withtag $item

      set anf [expr $end -1]
      set end [expr $anf + [min [expr $len- $end] 15001]]
   }
  }
}

