# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc niceboxselector {} {
global can pwd toolflag casesensitive
global comvarlist nicevarlist
global boxFont nicebuttoncolor
global nicevarbut
global mapname

if {[file exists $pwd/map.info]} {
 set id [open $pwd/map.info]
 gets $id line
 set mapname $line
 close $id
} else {
   return
}

initmapview
mapview
bindnicebox
}


proc bindnicebox {} {
global can pwd toolflag upper
global newset negraph
global canvas actbox

for {set i 1} {$i <= $actbox} {incr i} {
     set box [lindex $upper [expr $i-1]]

     $canvas bind     num($i) <1> "makecommand -1 $box"
     $canvas bind drawbox($i) <1> "makecommand -1 $box"

     if {$toolflag == "overview" || $toolflag == "phase"} {
        $canvas bind     num($i) <2> "set newset 1;makecommand -1 $box"
        $canvas bind drawbox($i) <2> "set newset 1;makecommand -1 $box"
     }
     if {$toolflag != "phase"} {
        $canvas bind     num($i) <3> "set newgraph 1;makecommand -1 $box"
        $canvas bind drawbox($i) <3> "set newgraph 1;makecommand -1 $box"
     }

}

}


