# MOVIE 5.0 Copyright (C) 2020, Cora Kohlmeier, Frank Hamberg

proc normal_box_selector {} {
global DOS
global can
global varlist boxlist nicevarlist
global comvarlist comboxlist
global varrem boxrem
global boxwin varwin
global newset newgraph
global toolflag
global filename
global casesensitive
global boxFont
global varbut boxbut var_butwid_extra box_butwid_extra
global buttoncolor
global onewindow bs vs

# Box Selector
#-------------
if {($toolflag == "overview") || ($toolflag == "compare") || ($toolflag == "text") || $toolflag == "phase" } {
  if {$onewindow==0} {
	if {[info exist bs] && [winfo exist $bs]} {destroy $bs}
    set bs .bs
    toplevel .bs
    wm title .bs {Box Selector}
    wm geometry .bs "+50+[expr $can +150]"
    wm group .bs .
    wm transient .bs .
    wm protocol .bs WM_DELETE_WINDOW exit
  } 
  #Falls schon was da ist
  if [winfo exist $bs] {
	set kids [winfo children $bs]
	foreach kid $kids {destroy $kid}
  }
  set count 0
  set framecount 0

  frame $bs.$framecount
  pack $bs.$framecount -fill x
  
# Number of columns
  set column [expr int($can/31)]
  set boxbut ""
  set butwid 3

  foreach box $comboxlist {
   if ![winfo exists $bs.$framecount.$box] {
  
     set butwid [max $butwid [string length $box]]

# Number of columns
     set offset [expr int(fmod($count,$column)) ]
     set count [expr $count+1]

     if {$offset ==0} {
      set framecount [expr $framecount+1]
      frame $bs.$framecount
      pack $bs.$framecount  -fill x
   
     }

     button $bs.$framecount.$box -text $box \
           -command "makecommand -1 $box" -font $boxFont -width 10
     pack $bs.$framecount.$box -side left -fill x

     lappend boxbut $bs.$framecount.$box
     
     if {$toolflag == "overview" || $toolflag == "phase"} {
       bind $bs.$framecount.$box <2> {tkButton2Down %W}
       bind $bs.$framecount.$box <ButtonRelease-2> \
              "set newset 1;makecommand -1 $box;tkButton2Up %W"
        # For systems without 2nd mouse button
        bind $bs.$framecount.$box <Shift-1> "set newset 1;makecommand -1 $box"

     }


     if {$toolflag != "phase"} {
        bind $bs.$framecount.$box <3> {tkButton3Down %W}
        bind $bs.$framecount.$box <ButtonRelease-3> \
              "set newgraph 1;makecommand -1 $box;tkButton3Up %W"

# For systems without 3rd mouse button
        bind $bs.$framecount.$box <Control-1> "set newgraph 1;makecommand -1 $box"


     }
   }
  }
  if [info exists boxwin] {unset boxwin}
  set ll [winfo children $bs]
  foreach l $ll { append boxwin [winfo children $l] " "}
  if {[llength $boxwin]==0} {textinfo "No common boxes" 1}

  set butwid [expr $butwid + $box_butwid_extra] 
  foreach but $boxbut {$but config -width $butwid -padx 1}
  pack $bs.$framecount -fill x

# Falls 0D Modell braucht es keinen Boxselektor
  if {$boxbut=="$bs.1.0"} {wm withdraw $bs}
      
 makecommand [lindex $comvarlist 0] [lindex $comboxlist 0]
 #makecommand -1 -1
}

}

