# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc setvars {} {
#global preferences; set preferences global
#global taglist
#set taglist [concat axis $colorlist]

############################################################
global toolflag 
global setapply
global pwd

global minnumber;set minnumber -9999999999999999999999
global maxnumber;set maxnumber  9999999999999999999999
global longnames;set longnames 0
global maxgraph;   set maxgraph 8
global colorscheme;if ![info exist colorscheme] {set colorscheme classic} 	
global plotcolorlist;if ![info exist plotcolorlist] {set plotcolorlist default} 
global can;if ![info exist can] {set can 600}
global remembertool;if ![info exist remembertool] {set remembertool 0}
global nicevar;if ![info exist nicevar] {set nicevar 0}
global nicevarfile;if ![info exist nicevarfile] {set nicevarfile $pwd/nicevar.info}

if [info exist toolflag] {
      switch $toolflag {
            overview {set setapply 1}
            compare {set setapply 1}
            text {set setapply 1; set maxgraph 19}
            phase {set setapply 1}
            film {set setapply 0}
            profile {set setapply 1}
            profcom {set setapply 1}
            contour {set setapply 0}
      }
}

global maxfiles;set maxfiles 5
global runmean;   set runmean 0
global stepmean;   set stepmean 0
global stepsum;   set stepsum 0
global autocorr;   set autocorr 0

global xvgr_flag;   set xvgr_flag 0
global matlab_flag;   set matlab_flag 0
global maxset;   set maxset 19

global sameaxis;   set sameaxis 0
global firstaxis;   set firstaxis 0
global prettyaxis;   set prettyaxis 1
global startonzero;   set startonzero 1
global xgrid;set xgrid 0
global ygrid;set ygrid 0

global specialticklist; set specialticklist ""
global smooth;   set smooth 0
global barchart;   set barchart 0
global newset;   set newset 0
global plusflag;   set plusflag 0
global minusflag;   set minusflag 0
global eraseset;   set eraseset 0
global timesflag;   set timesflag 0
global timesfactor;   set timesfactor 1
global timesvarflag;   set timesvarflag 0
global divflag;   set divflag 0
global divvarflag;   set divvarflag 0
global meanflag;   set meanflag 0
global sumflag;set sumflag 0
global logflag; set logflag 0

global gnu_flag;set gnu_flag 0

global gc;   set gc 0
global newgraph;   set newgraph 0
global erasegraph;   set erasegraph 0
global eraseallgraphs;   set eraseallgraphs 0
global eraseallsets;   set eraseallsets 0
global gl;   set gl {zero one two three four five six seven eight}

global valu;   set valu 0
global calc_l2dist;  set calc_l2dist 0
global exact; set exact 0
global spectrum;   set spectrum 0
global multiset;   set multiset 0

global fixvar;   set fixvar 0
global fixbox;   set fixbox 0
global aoag;   set aoag 0

global points; set points 0;
global fixymin; set fixymin ""
global fixymax; set fixymax ""
global datawin; set datawin ""

#Compare
global power_spec;set power_spec 0
global connect; set connect 1
global harm; set harm 0
global showbars;set showbars 1
global showline;set showline 0

global datalist valushow

if [info exist datalist] {
  foreach a $datalist {set valushow($a) 0}
}
global allyear;set allyear 1
global allboxes;set allboxes 0
global alldataboxes;set alldataboxes 0

#Profile and ProfCom
global time;set time 0
global flipxy; set flipxy 0
global timemaxflag; set timemaxflag 0
global layervalue; set layervalue 0
global evallayer; set evallayer 1

#Contour and Film
global markzeros;set markzeros 1
global borders;set borders 0
global numbers; set numbers 0

#PhaseTool
global calcext;set calcext 1
global phasescale;set phasescale 0
global seq; set seq 0
global command
global sc

for {set i 0} {$i <=$maxgraph} {incr i} {set command($i) X; set sc($i) 0}
# Reading .tkmovieset
global home

set name $home/.tkmovieset

if [file exist $name] {
  set id [open $name r]
  while {[gets $id line] >=0} {
    eval $line
  }
}
}


