# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

#########################################
# Main Overview procedure called from mov
#########################################
proc PhaseControl {} {
global can ovc
global actstart timewin
global starttime endtime outd
global buttonFont

makeslider
#bind $ovc <3> {makeboxslider}
control_bindings
set_and_graph set
sequence_buttons

frame $ovc.right
grid $ovc.right -row 0 -column 2 -sticky news

frame $ovc.right.fix
pack $ovc.right.fix -side top -anchor w

fix

checkbutton $ovc.right.fix.soz  -font $buttonFont -text {start on zero} \
       -variable startonzero  -anchor w
pack $ovc.right.fix.soz -fill x
set startonzero 0
 $ovc.right.fix.soz invoke 

checkbutton $ovc.right.fix.phsc  -font $buttonFont -text {scale} \
       -variable phasescale -anchor w
pack $ovc.right.fix.phsc -fill x

checkbutton $ovc.right.fix.points  -font $buttonFont -text {points} \
       -variable points -anchor w
pack $ovc.right.fix.points -fill x

frame $ovc.right.misc
pack $ovc.right.misc -side top -pady {0 5}

apply_button
right_buttons
 
makeselector
makecommand -1 -1
}


