# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc csv2symb {} {
global pwd prep_command log moviehome

wm attributes .prepare -topmost no
set filename [fileselect  "Select result file" csv $pwd open]
wm attributes .prepare -topmost yes
if {$filename==""} {return}

$log delete 1.0 end
$log insert end "Converting $filename "

set ext [file extension $filename]
#regsub $ext $filename "" file
set file [file rootname $filename]

$log insert end "to $file.symb \n"


makesymb $filename $file.symb


$log insert end "Ready :)"


}

