# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

# Setzt Daten von result->symb um. d.h
# Variablennamen klein
# Zeit für jede Variable duplizieren
# time -> /tim/ wandeln
proc result2symb {} {
global pwd prep_command log moviehome
wm attributes .prepare -topmost no
set filename [fileselect  "Select result file" outc $pwd open]
wm attributes .prepare -topmost yes
if {$filename==""} {return}

$log delete 1.0 end
$log insert end "Converting $filename "

set ext [file extension $filename]
set file [file rootname $filename]

#set prep_command "$moviehome/../cprog/result2outa $filename ".$file" all all"
#Run
exec $moviehome/../cprog/result2outa $filename $file\_tmp all all

set ext [string trimleft $ext .]
set outfile $file\_$ext.symb

$log insert end "to $outfile \n"


makesymb2 $file\_tmp.outa $outfile
file delete -force $file\_tmp.outa

$log insert end "Ready :)"


}

