# MOVIE 5.0 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc prep_profcom {j extract} {
# j = graph

global command
global sameaxis
global filename filelist
global singleresult
global lbar
global timemin timemax
global minnumber maxnumber 


set selectvar [lindex $command($j) 0]

set timeminrem($j)  $maxnumber
set timemaxrem($j)  $minnumber
set lbar 0

foreach k $filelist {

  if [info exists filename($k)] {
    if {$extract == "YES"} {extract_profdata $k}
    eval_prof_slid $j $k
    calc_prof_ext $j $k

    set singleresult($k,$selectvar) $singleresult($selectvar)

    set timeminrem($j) [min $timeminrem($j) $timemin($j)]
    set timemaxrem($j) [max $timemaxrem($j) $timemax($j)]
    incr lbar
  }
}

set timemin($j) $timeminrem($j)
set timemax($j) $timemaxrem($j)

#if {$sameaxis == 1} {calc_glob_prof_ext}

} 


